import { AnyCodec } from './definitions';
export declare enum TransformTarget {
    Encoded = "encoded",
    Decoded = "decoded"
}
export declare type CommonParams = {
    target: TransformTarget;
    parsers: Parser<string, AnyCodec>[];
    allowAdditional: boolean;
};
export declare type GenerationOptions = Partial<CommonParams>;
declare type RecursiveCodecCache = Map<string, any>;
declare type GenerationContext = CommonParams & {
    cache: RecursiveCodecCache;
};
export declare type ParserFunction<C extends AnyCodec> = (codec: C, options: GenerationContext) => object;
export declare type Parser<T extends string, C extends AnyCodec> = {
    tag: T;
    parse: ParserFunction<C>;
};
export declare const createParser: <C extends AnyCodec, T extends string = string>(tag: T, parser: ParserFunction<C>) => Parser<T, C>;
export declare const generateJSONSchema: (codec: AnyCodec, options?: Partial<CommonParams> | undefined) => Record<string, any>;
export {};
